"use strict";

exports.__esModule = true;
exports.Buttons = exports.Button = void 0;

var _react = _interopRequireDefault(require("react"));

var _ = require("../../");

var _reactPowerplug = require("react-powerplug");

var _epitath = _interopRequireDefault(require("epitath"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Handle our sizes
 */
var handleSize = function handleSize(_ref) {
  var size = _ref.size,
      rest = _objectWithoutPropertiesLoose(_ref, ["size"]);

  if (size === 'small') {
    return _extends({}, rest, {
      px: 4,
      height: '36px',
      type: _extends({}, rest.type, {
        fontSize: 1
      })
    });
  }

  return _extends({}, rest);
};
/**
 * Inverts the colors to white
 */


var handleInvert = function handleInvert(_ref2) {
  var invert = _ref2.invert,
      hovered = _ref2.hovered,
      active = _ref2.active,
      disabled = _ref2.disabled,
      rest = _objectWithoutPropertiesLoose(_ref2, ["invert", "hovered", "active", "disabled"]);

  return invert ? _extends({}, rest, {
    bg: 'white',
    color: rest.bg
  }) : rest;
};
/**
 * Makes a button outlined
 */


var handleOutline = function handleOutline(_ref3) {
  var outline = _ref3.outline,
      rest = _objectWithoutPropertiesLoose(_ref3, ["outline"]);

  return outline ? _extends({}, rest, {
    bg: 'transparent',
    borderColor: rest.bg,
    color: rest.bg
  }) : rest;
};
/**
 * This removes any props we don't want passed along to the final component/dom element
 */


var cleanProps = function cleanProps(_ref4) {
  var hovered = _ref4.hovered,
      active = _ref4.active,
      outline = _ref4.outline,
      invert = _ref4.invert,
      rest = _objectWithoutPropertiesLoose(_ref4, ["hovered", "active", "outline", "invert"]);

  return rest;
};

var propFn = function propFn(props) {
  return cleanProps(handleOutline(handleInvert(handleSize(props))));
};

var Button = (0, _epitath.default)(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee(_ref5) {
  var children, disabled, Icon, outline, invert, rest, _ref6, active, activeBind, _ref7, hovered, hoverBind, bind, defaultProps, _propFn, type, props, buttonProps, labelProps, IconComponent;

  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          children = _ref5.children, disabled = _ref5.disabled, Icon = _ref5.icon, outline = _ref5.outline, invert = _ref5.invert, rest = _objectWithoutPropertiesLoose(_ref5, ["children", "disabled", "icon", "outline", "invert"]);
          _context.next = 3;
          return _react.default.createElement(_reactPowerplug.Active, null);

        case 3:
          _ref6 = _context.sent;
          active = _ref6.active;
          activeBind = _ref6.bind;
          _context.next = 8;
          return _react.default.createElement(_reactPowerplug.Hover, null);

        case 8:
          _ref7 = _context.sent;
          hovered = _ref7.hovered;
          hoverBind = _ref7.bind;
          bind = _extends({}, activeBind, hoverBind);
          defaultProps = {
            display: 'inline-flex',
            alignItems: 'center',
            justifyContent: 'center',
            px: 5,
            height: '48px',
            borderColor: 'transparent',
            bg: hovered ? 'blue' : 'blue.dark',
            color: 'white',
            border: 2,
            borderRadius: 50,
            boxShadow: hovered ? 'button.hover' : 'button',
            fontWeight: 'semibold',
            variant: 'default',
            fontSize: 2,
            type: {
              fontSize: 2
            }
          };
          _propFn = propFn(_extends({}, defaultProps, {
            hovered: hovered ? 'true' : undefined,
            active: active ? 'true' : undefined,
            outline: outline,
            invert: invert
          }, rest)), type = _propFn.type, props = _objectWithoutPropertiesLoose(_propFn, ["type"]);
          buttonProps = _extends({}, props, bind, {
            style: {
              cursor: !disabled && hovered ? 'pointer' : undefined,
              transition: '.34s all cubic-bezier(.19,1,.22,1)',
              transform: active ? 'translateY(2px)' : 'none',
              outline: 'none'
            }
          });
          labelProps = _extends({}, type, {
            style: {
              whiteSpace: 'nowrap'
            },
            display: 'inline-block'
          });

          IconComponent = function IconComponent(_ref8) {
            var borderColor = _ref8.borderColor,
                color = _ref8.color,
                p = _objectWithoutPropertiesLoose(_ref8, ["borderColor", "color"]);

            return Icon ? _react.default.createElement(_.Flex, {
              alignItems: "center",
              justifyContent: "center",
              color: outline ? borderColor : invert ? color : 'blue.accent',
              pl: 2
            }, _react.default.createElement(Icon, {
              color: "currentColor",
              size: "1.2rem",
              style: {
                display: 'block'
              }
            })) : null;
          };

          return _context.abrupt("return", _react.default.createElement(_.Flex, _extends({}, buttonProps, {
            is: "button"
          }), _react.default.createElement(_.Type, labelProps, children), _react.default.createElement(IconComponent, buttonProps)));

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
}));
exports.Button = Button;
var Buttons = _.Flex;
exports.Buttons = Buttons;
Buttons.defaultProps = {
  justifyContent: 'space-evenly'
};
Button.propTypes = {
  outline: _propTypes.default.bool,
  invert: _propTypes.default.bool,
  size: _propTypes.default.oneOf(['small'])
};