"use strict";

exports.__esModule = true;
exports.Inline = exports.Flex = exports.Box = exports.StyledSystem = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _cleanTag = _interopRequireDefault(require("clean-tag"));

var _cleanElement = _interopRequireDefault(require("clean-element"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledSystem = require("styled-system");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteralLoose(strings, raw) { if (!raw) { raw = strings.slice(0); } strings.raw = raw; return strings; }

var Box = (0, _styledComponents.default)((0, _cleanElement.default)(_cleanTag.default))(_templateObject(), _styledSystem.space, _styledSystem.width, _styledSystem.fontSize, _styledSystem.color, _styledSystem.fontFamily, _styledSystem.textAlign, _styledSystem.lineHeight, _styledSystem.fontWeight, _styledSystem.fontStyle, _styledSystem.letterSpacing, _styledSystem.display, _styledSystem.maxWidth, _styledSystem.minWidth, _styledSystem.height, _styledSystem.maxHeight, _styledSystem.minHeight, _styledSystem.sizeWidth, _styledSystem.sizeHeight, _styledSystem.size, _styledSystem.ratioPadding, _styledSystem.ratio, _styledSystem.verticalAlign, _styledSystem.alignItems, _styledSystem.alignContent, _styledSystem.justifyItems, _styledSystem.justifyContent, _styledSystem.flexWrap, _styledSystem.flexBasis, _styledSystem.flexDirection, _styledSystem.flex, _styledSystem.justifySelf, _styledSystem.alignSelf, _styledSystem.order, _styledSystem.gridGap, _styledSystem.gridColumnGap, _styledSystem.gridRowGap, _styledSystem.gridColumn, _styledSystem.gridRow, _styledSystem.gridAutoFlow, _styledSystem.gridAutoColumns, _styledSystem.gridAutoRows, _styledSystem.gridTemplateColumns, _styledSystem.gridTemplateRows, _styledSystem.gridTemplateAreas, _styledSystem.gridArea, _styledSystem.borders, _styledSystem.borderColor, _styledSystem.borderRadius, _styledSystem.boxShadow, _styledSystem.opacity, _styledSystem.overflow, _styledSystem.background, _styledSystem.backgroundImage, _styledSystem.backgroundPosition, _styledSystem.backgroundRepeat, _styledSystem.backgroundSize, _styledSystem.position, _styledSystem.zIndex, _styledSystem.top, _styledSystem.right, _styledSystem.bottom, _styledSystem.left, _styledSystem.textStyle, _styledSystem.buttonStyle);
exports.Box = Box;

var Flex = function Flex(props) {
  return React.createElement(Box, _extends({
    display: "flex"
  }, props));
};

exports.Flex = Flex;

var Inline = function Inline(props) {
  return React.createElement(Box, _extends({
    is: "span"
  }, props));
};

exports.Inline = Inline;

var boxPropTypes = _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string, _propTypes.default.array]);

Box.propTypes = {
  width: boxPropTypes,
  p: boxPropTypes,
  py: boxPropTypes,
  px: boxPropTypes,
  pt: boxPropTypes,
  pb: boxPropTypes,
  pl: boxPropTypes,
  pr: boxPropTypes,
  m: boxPropTypes,
  my: boxPropTypes,
  mx: boxPropTypes,
  mt: boxPropTypes,
  mb: boxPropTypes,
  ml: boxPropTypes,
  mr: boxPropTypes,
  fontSize: boxPropTypes,
  color: boxPropTypes,
  flex: boxPropTypes,
  order: boxPropTypes,
  alignSelf: boxPropTypes,
  opacity: boxPropTypes,
  display: boxPropTypes,
  position: boxPropTypes,
  top: boxPropTypes,
  right: boxPropTypes,
  left: boxPropTypes,
  bottom: boxPropTypes,
  minHeight: boxPropTypes,
  borderRadius: boxPropTypes,
  maxHeight: boxPropTypes,
  maxWidth: boxPropTypes,
  minWidth: boxPropTypes,
  borders: boxPropTypes
};
Flex.propTypes = {
  width: boxPropTypes,
  p: boxPropTypes,
  py: boxPropTypes,
  px: boxPropTypes,
  pt: boxPropTypes,
  pb: boxPropTypes,
  pl: boxPropTypes,
  pr: boxPropTypes,
  m: boxPropTypes,
  my: boxPropTypes,
  mx: boxPropTypes,
  mt: boxPropTypes,
  mb: boxPropTypes,
  ml: boxPropTypes,
  mr: boxPropTypes,
  fontSize: boxPropTypes,
  color: boxPropTypes,
  flex: boxPropTypes,
  order: boxPropTypes,
  alignSelf: boxPropTypes,
  opacity: boxPropTypes,
  display: boxPropTypes,
  position: boxPropTypes,
  top: boxPropTypes,
  right: boxPropTypes,
  left: boxPropTypes,
  bottom: boxPropTypes,
  minHeight: boxPropTypes,
  borderRadius: boxPropTypes,
  maxHeight: boxPropTypes,
  maxWidth: boxPropTypes,
  minWidth: boxPropTypes,
  borders: boxPropTypes,
  justifyContent: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  flexWrap: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  alignItems: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  flexDirection: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array])
};
Inline.defaultProps = {
  display: 'inline-block'
};
Box.displayName = 'Box';
Flex.displayName = 'Flex';
Inline.displayName = 'Inline';
var StyledSystem = {
  space: _styledSystem.space,
  width: _styledSystem.width,
  fontSize: _styledSystem.fontSize,
  color: _styledSystem.color,
  fontFamily: _styledSystem.fontFamily,
  textAlign: _styledSystem.textAlign,
  lineHeight: _styledSystem.lineHeight,
  fontWeight: _styledSystem.fontWeight,
  fontStyle: _styledSystem.fontStyle,
  letterSpacing: _styledSystem.letterSpacing,
  display: _styledSystem.display,
  maxWidth: _styledSystem.maxWidth,
  minWidth: _styledSystem.minWidth,
  height: _styledSystem.height,
  maxHeight: _styledSystem.maxHeight,
  minHeight: _styledSystem.minHeight,
  sizeWidth: _styledSystem.sizeWidth,
  sizeHeight: _styledSystem.sizeHeight,
  size: _styledSystem.size,
  ratioPadding: _styledSystem.ratioPadding,
  ratio: _styledSystem.ratio,
  verticalAlign: _styledSystem.verticalAlign,
  alignItems: _styledSystem.alignItems,
  alignContent: _styledSystem.alignContent,
  justifyItems: _styledSystem.justifyItems,
  justifyContent: _styledSystem.justifyContent,
  flexWrap: _styledSystem.flexWrap,
  flexBasis: _styledSystem.flexBasis,
  flexDirection: _styledSystem.flexDirection,
  flex: _styledSystem.flex,
  justifySelf: _styledSystem.justifySelf,
  alignSelf: _styledSystem.alignSelf,
  order: _styledSystem.order,
  gridGap: _styledSystem.gridGap,
  gridColumnGap: _styledSystem.gridColumnGap,
  gridRowGap: _styledSystem.gridRowGap,
  gridColumn: _styledSystem.gridColumn,
  gridRow: _styledSystem.gridRow,
  gridAutoFlow: _styledSystem.gridAutoFlow,
  gridAutoColumns: _styledSystem.gridAutoColumns,
  gridAutoRows: _styledSystem.gridAutoRows,
  gridTemplateColumns: _styledSystem.gridTemplateColumns,
  gridTemplateRows: _styledSystem.gridTemplateRows,
  gridTemplateAreas: _styledSystem.gridTemplateAreas,
  gridArea: _styledSystem.gridArea,
  borders: _styledSystem.borders,
  borderColor: _styledSystem.borderColor,
  borderRadius: _styledSystem.borderRadius,
  boxShadow: _styledSystem.boxShadow,
  opacity: _styledSystem.opacity,
  overflow: _styledSystem.overflow,
  background: _styledSystem.background,
  backgroundImage: _styledSystem.backgroundImage,
  backgroundPosition: _styledSystem.backgroundPosition,
  backgroundRepeat: _styledSystem.backgroundRepeat,
  backgroundSize: _styledSystem.backgroundSize,
  position: _styledSystem.position,
  zIndex: _styledSystem.zIndex,
  top: _styledSystem.top,
  right: _styledSystem.right,
  bottom: _styledSystem.bottom,
  left: _styledSystem.left,
  textStyle: _styledSystem.textStyle,
  buttonStyle: _styledSystem.buttonStyle
};
exports.StyledSystem = StyledSystem;