"use strict";

exports.__esModule = true;
exports.Headings = exports.H1 = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _primitives = require("../primitives");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _templateObject() {
  var data = _taggedTemplateLiteralLoose([""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteralLoose(strings, raw) { if (!raw) { raw = strings.slice(0); } strings.raw = raw; return strings; }

var Headings = _styledComponents.default.div(_templateObject());

exports.Headings = Headings;

var H1 = function H1(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h1"
  }, p));
};

exports.H1 = H1;
H1.defaultProps = {
  fontFamily: 'brand',
  lineHeight: 1.5,
  fontSize: 7,
  color: 'blue',
  fontWeight: 'light',
  m: 0
};

var H2 = function H2(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h2"
  }, p));
};

H2.defaultProps = {
  lineHeight: 1.5,
  fontSize: 6,
  color: 'blue.dark',
  fontWeight: 'light',
  fontFamily: 'default',
  m: 0
};

var H3 = function H3(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h3"
  }, p));
};

H3.defaultProps = {
  lineHeight: 1.5,
  fontSize: 5,
  color: 'blue.dark',
  fontWeight: 'normal',
  fontFamily: 'default',
  m: 0
};

var H4 = function H4(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h4"
  }, p));
};

H4.defaultProps = {
  lineHeight: 1.5,
  fontSize: 4,
  fontWeight: 'normal',
  fontFamily: 'default',
  color: 'blue.dark',
  m: 0
};

var H5 = function H5(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h5"
  }, p));
};

H5.defaultProps = {
  lineHeight: 1.5,
  fontSize: 3,
  fontFamily: 'default',
  fontWeight: 'semibold',
  color: 'blue.dark',
  m: 0
};

var H6 = function H6(p) {
  return React.createElement(_primitives.Inline, _extends({
    is: "h6"
  }, p));
};

H6.defaultProps = {
  lineHeight: 1.5,
  fontSize: 2,
  fontFamily: 'default',
  fontWeight: 'semibold',
  color: 'blue.mid',
  m: 0
};

Headings.H1 = function (props) {
  return React.createElement(H1, props);
};

Headings.H2 = function (props) {
  return React.createElement(H2, props);
};

Headings.H3 = function (props) {
  return React.createElement(H3, props);
};

Headings.H4 = function (props) {
  return React.createElement(H4, props);
};

Headings.H5 = function (props) {
  return React.createElement(H5, props);
};

Headings.H6 = function (props) {
  return React.createElement(H6, props);
};